
package org.xdat.actionListeners.parallelCoordinatesChartFrame;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import org.xdat.Main;
import org.xdat.chart.ParallelSetsAxis;
import org.xdat.gui.dialogs.SplitMergeCategoriesDialog;
import org.xdat.gui.frames.ChartFrame;


public class ParallelSetsCategoriesMenuActionListener implements ActionListener {

	static final boolean printLog = false;
	private Main mainWindow;
	private ChartFrame chartFrame;
	private ParallelSetsAxis axis;

	public ParallelSetsCategoriesMenuActionListener(Main mainWindow, ChartFrame chartFrame, ParallelSetsAxis axis) {
		this.mainWindow = mainWindow;
		this.chartFrame = chartFrame;
		this.axis = axis;

	}

	public void actionPerformed(ActionEvent e) {
		String actionCommand = e.getActionCommand();
		if (actionCommand.equals("splitMergeCategories")) {
                    new SplitMergeCategoriesDialog(chartFrame, mainWindow, axis);
		} else {
			System.out.println(e.getActionCommand());
		}
	}

	private void log(String message) {
		if (ParallelChartContextMenuActionListener.printLog && Main.isLoggingEnabled()) {
			System.out.println(this.getClass().getName() + "." + message);
		}
	}

}
