/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.chart;

import java.util.ArrayList;

import org.xdat.data.Design;

/**
 * Representation of set intersection
 *
 * @author cmolikl
 */
public class AxisCategoryAndCondition extends AxisCategoryConditionAbstract {
    
    protected ArrayList<AxisCategoryCondition> conditions = new ArrayList<>();
    private String label = null;

    public AxisCategoryAndCondition() {
    }
    
    public AxisCategoryAndCondition(AxisCategoryCondition... conditions) {
        for(AxisCategoryCondition condition : conditions) {
            this.conditions.add(condition);
        }
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public void addCondition(AxisCategoryCondition c) {
        conditions.add(c);

    }
    
    public void removeCondition(AxisCategoryCondition c) {
        conditions.remove(c);
    }
    
    @Override
    public boolean test(Design d) {
        for(AxisCategoryCondition c : conditions) {
            if(!c.test(d)) return false;
        }
        return true;
    }

    @Override
    public String getLabel() {
        if(label != null) return label;
        if(conditions.isEmpty()) return "And condition";
        String label = "";
        int i = 0;
        for(AxisCategoryCondition c : conditions) {
            label += c.getLabel(); 
            i++;
            if(i < conditions.size()) label += " and \n";
        }
        return label;
    }
    
    public int size() {
        return conditions.size();
    }

    @Override
    public AxisCategoryCondition clone() {
        AxisCategoryAndCondition copy = new AxisCategoryAndCondition();
        copy.conditions = new ArrayList<>();
        for(AxisCategoryCondition cond : conditions) {
            copy.conditions.add(cond.clone());
        }
        return copy;
    }

    @Override
    public String toString() {
        return "And";
    }
}
