/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.chart;

import java.util.HashMap;
import org.xdat.data.Design;

/**
 * Representation of set union
 *
 * @author cmolikl
 */
public class AxisCategoryOrCondition extends AxisCategoryConditionAbstract {
    
    private HashMap<String, AxisCategoryCondition> conditions = new HashMap<>();

    public AxisCategoryOrCondition(AxisCategoryCondition... conditions) {
        for(AxisCategoryCondition condition : conditions) {
            this.conditions.put(condition.getLabel(), condition);
        }
    }
    
    @Override
    public boolean test(Design d) {
        for(AxisCategoryCondition condition : conditions.values()) {
            if(condition.test(d)) return true;
        }
        return false;
    }
    
    @Override
    public String getLabel() {
        if(conditions.isEmpty()) return "Or condition";
        String label = "";
        int i = 0;
        for(String l : conditions.keySet()) {
            label += l;
            i++;
            if( i < conditions.size()) label += " or ";
        }
        return label;
    }
    
    public int size() {
        return conditions.size();
    }
    
    public void addCondition(AxisCategoryCondition c) {
        conditions.put(c.getLabel(), c);
    }
    
    public void removeCondition(AxisCategoryCondition c) {
        conditions.remove(c.getLabel());
    }

    @Override
    public AxisCategoryCondition clone() {
        AxisCategoryOrCondition copy = new AxisCategoryOrCondition();
        copy.conditions = new HashMap<>();
        for(AxisCategoryCondition cond : conditions.values()) {
            copy.conditions.put(cond.getLabel(), cond.clone());
        }
        return copy;
    }

    @Override
    public String toString() {
        return "Or";
    }
}
