/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.chart;

import org.xdat.data.Design;
import org.xdat.data.Parameter;

/**
 *
 * @author cmolikl
 */
public class AxisCategoryStringCondition extends AxisCategoryConditionAbstract {

    private String condition;
    private Parameter p;
    
    public AxisCategoryStringCondition(String value, Parameter p) {
        this.condition = value;
        this.p = p;
    }
    
    public boolean test(Design d) {
        if(p.isNumeric() && !p.isOneNonNumeric()) return false;
        String value = d.getStringValue(p);
        return condition.equals(value);
    }
    
    public String getLabel() {
        return condition;
    }
    
    public String getString() {
        return condition;
    }
    
    public int size() {
        return 1;
    }
    
    public Parameter getParameter() {
        return p;
    }

    public ParallelSetsAxis getAxis() {
        return (ParallelSetsAxis) p.getAxis();
    }

    @Override
    public AxisCategoryCondition clone() {
        AxisCategoryStringCondition copy = new AxisCategoryStringCondition(condition, p);
        return copy;
    }
}
