
package org.xdat.chart;

import java.awt.Color;
import java.io.Serializable;
import java.util.List;
import org.xdat.data.Design;

/**
 * Representation of parallelogram inside the axis of parallel sets chart.
 *
 * @author Martin Janda
 */
public class InsideDesignSet implements Serializable {
    private float height;
    private float inputY;
    private float outputY;
    private int inputIndex;
    private int outputIndex;
    private AxisCategory category;
    private DesignSet inputSet;
    private DesignSet outputSet;
    private List<Design> designs;
    private Color color;

    public InsideDesignSet(AxisCategory category, int inputIndex, int outputIndex, DesignSet inputSet, DesignSet outputSet, List<Design> designs, Color color) {
        this.category = category;
        this.inputIndex = inputIndex;
        this.outputIndex = outputIndex;
        this.inputSet = inputSet;
        this.outputSet = outputSet;
        this.height = 0;
        this.inputY = 0;
        this.outputY = 0;
        this.designs = designs;
        this.color = color;
    }
    
    public AxisCategory getCategory(){
        return category;
    }
    
    public void setCategory(AxisCategory category){
        this.category = category;
    }
    
    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public List<Design> getDesigns() {
        return designs;
    }

    public void setDesigns(List<Design> designs) {
        this.designs = designs;
    }

    public int getInputIndex() {
        return inputIndex;
    }

    public void setInputIndex(int inputIndex) {
        this.inputIndex = inputIndex;
    }

    public int getOutputIndex() {
        return outputIndex;
    }

    public void setOutputIndex(int outputIndex) {
        this.outputIndex = outputIndex;
    }

    public float getInputY() {
        return inputY;
    }

    public void setInputY(float inputY) {
        this.inputY = inputY;
    }

    public float getOutputY() {
        return outputY;
    }

    public void setOutputY(float outputY) {
        this.outputY = outputY;
    }

    public DesignSet getInputSet() {
        return inputSet;
    }

    public void setInputSet(DesignSet inputSet) {
        this.inputSet = inputSet;
    }

    public DesignSet getOutputSet() {
        return outputSet;
    }

    public void setOutputSet(DesignSet outputSet) {
        this.outputSet = outputSet;
    }

    public float getHeight() {
        return height;
    }

    public void setHeight(float height) {
        this.height = height;
    }
    
    
    
}
