package org.xdat.chart;

import org.xdat.UserPreferences;
import org.xdat.data.DataSheet;

import java.awt.*;
import java.awt.font.TextAttribute;
import java.util.HashMap;
import java.util.Map;

public class ParallelSetsAxisWithoutParameter extends ParallelSetsAxis {

    private String name;

    public ParallelSetsAxisWithoutParameter(DataSheet dataSheet, ParallelSetsChart chart, String name){
        this.dataSheet = dataSheet;
        this.chart = chart;
        initialiseSettings();

        if (this.autoFit) autofit();
        position = new Point(0, 0);
        selected = false;
        expanded = false;
        this.parallelSetsChart = chart;
        coordinatesAxis = false;
        inverted = false;

        int labelFontSize = UserPreferences.getInstance().getParallelCoordinatesAxisLabelFontSize();
        labelFont = new Font("SansSerif", Font.PLAIN, labelFontSize);
        Map<TextAttribute, Integer> fontAttributes = new HashMap<>();
        fontAttributes.put(TextAttribute.UNDERLINE, TextAttribute.UNDERLINE_ON);
        labelFontSelected = labelFont.deriveFont(fontAttributes);
        int ticFontSize = UserPreferences.getInstance().getParallelCoordinatesAxisTicLabelFontSize();
        ticFont = new Font("SansSerif", Font.PLAIN, ticFontSize);

        this.name = name;

        setUserSorted(true);
    }

    @Override
    public void autofit() {
    }

    @Override
    public double getMax() {
        return max;
    }

    @Override
    public double getMin() {
        return min;
    }

    @Override
    public double getRange() {
        return max - min;
    }

    @Override
    public int getTicCount() {
        return 0;
    }

    @Override
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Override
    public void setActive(boolean active) {
        this.active = active;
    }

    @Override
    public boolean isAutoFit() {
        return autoFit;
    }
}
