/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.example;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.ProgressMonitor;
import org.xdat.Main;
import org.xdat.UserPreferences;
import org.xdat.chart.ParallelSetsChart;
import org.xdat.data.DataSheet;
import org.xdat.data.Parameter;
import org.xdat.exceptions.NoParametersDefinedException;
import org.xdat.gui.frames.ChartFrame;

/**
 *
 * @author cmolikl
 */
public class AppStore {
    public static void main(String... args) {
        try {
            String filePath = args[0];
            String delimiter = args[1];
            Boolean header = Boolean.parseBoolean(args[2]);
            
            Main main = new Main();
            
            UserPreferences userPreferences = UserPreferences.getInstance();
            userPreferences.setDelimiter(delimiter);
            userPreferences.setTreatConsecutiveAsOne(false);
           
            ProgressMonitor progressMonitor = new ProgressMonitor(main, "", "Importing Data...", 0, 100);
            progressMonitor.setProgress(0);

            DataSheet dataSheet = new DataSheet(filePath, header, main, progressMonitor);
            
            main.setDataSheet(dataSheet);
            main.repaint();
            
            Parameter p = dataSheet.getParameter("name");
            p.setActive(false);
            p = dataSheet.getParameter("id");
            p.setActive(false);
            
            progressMonitor = new ProgressMonitor(main, "", "Creating chart...", 0, 100);
            progressMonitor.setProgress(0);

            // TODO get ColumnModel for chart
            ParallelSetsChart chart = new ParallelSetsChart(dataSheet, null, progressMonitor, main.getUniqueChartId(ParallelSetsChart.class));
	    ChartFrame chartFrame = new ChartFrame(main, chart);
            main.getCurrentSession().addChart(chart);
            
        }
        catch(IOException e) {
            e.printStackTrace();
        } catch (NoParametersDefinedException ex) {
            ex.printStackTrace();
        }
    }
}
