/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.example;

import java.io.IOException;
import javax.swing.ProgressMonitor;
import org.xdat.Main;
import org.xdat.UserPreferences;
import org.xdat.chart.AxisCategoryAndCondition;
import org.xdat.chart.AxisCategoryOrCondition;
import org.xdat.chart.AxisCategoryRangeCondition;
import org.xdat.chart.AxisCategoryStringCondition;
import org.xdat.chart.ParallelSetsAxis;
import org.xdat.chart.ParallelSetsChart;
import org.xdat.data.DataSheet;
import org.xdat.data.Design;
import org.xdat.data.Parameter;
import org.xdat.exceptions.NoParametersDefinedException;
import org.xdat.gui.frames.ChartFrame;

/**
 *
 * @author cmolikl
 */
public class Cereals {
    public static void main(String... args) {
        try {
            String filePath = args[0];
            String delimiter = args[1];
            Boolean header = Boolean.parseBoolean(args[2]);
            
            Main main = new Main();
            
            UserPreferences userPreferences = UserPreferences.getInstance();
            userPreferences.setDelimiter(delimiter);
            userPreferences.setTreatConsecutiveAsOne(false);
           
            ProgressMonitor progressMonitor = new ProgressMonitor(main, "", "Importing Data...", 0, 100);
            progressMonitor.setProgress(0);

            DataSheet dataSheet = new DataSheet(filePath, header, main, progressMonitor);
            
            Parameter p = dataSheet.getParameter("mfr");
            p.setNumeric(false);
            p = dataSheet.getParameter("type");
            p.setNumeric(false);
            p = dataSheet.getParameter("type");
            p.setNumeric(false);
            p = dataSheet.getParameter("protein");
            p.setNumeric(false);
            p = dataSheet.getParameter("fat");
            p.setNumeric(false);
            p = dataSheet.getParameter("vitamins");
            p.setNumeric(false);
            p = dataSheet.getParameter("shelf");
            p.setNumeric(false);
            p = dataSheet.getParameter("weight");
            p.setNumeric(false);
            p = dataSheet.getParameter("cups");
            p.setNumeric(false);
            
            
            //aggregate(dataSheet);
            
            main.setDataSheet(dataSheet);
            main.repaint();
            
            progressMonitor = new ProgressMonitor(main, "", "Creating chart...", 0, 100);
            progressMonitor.setProgress(0);

            // TODO get ColumnModel for chart
            ParallelSetsChart chart = new ParallelSetsChart(dataSheet, null, progressMonitor, main.getUniqueChartId(ParallelSetsChart.class));
            chart.getAxis("name").setActive(false);
            
	    ChartFrame chartFrame = new ChartFrame(main, chart);
            main.getCurrentSession().addChart(chart);
            
            
        }
        catch(IOException e) {
            e.printStackTrace();
        } catch (NoParametersDefinedException ex) {
            ex.printStackTrace();
        }
    }
    
    public static void aggregate(DataSheet ds) {
        Parameter economy = ds.getParameter("economy (mpg)");
        Parameter cylinders = ds.getParameter("cylinders");
        Parameter weight = ds.getParameter("weight (lb)");
        Parameter year = ds.getParameter("year");
        
        AxisCategoryRangeCondition eC = new AxisCategoryRangeCondition(16.52, 24.04, economy);
        AxisCategoryStringCondition cC = new AxisCategoryStringCondition("6.0", cylinders);
        AxisCategoryRangeCondition wC1 = new AxisCategoryRangeCondition(3023.8, 3729.2, weight);
        AxisCategoryRangeCondition wC2 = new AxisCategoryRangeCondition(2318.4, 3023.8, weight);
        
        AxisCategoryStringCondition yC70 = new AxisCategoryStringCondition("70.0", year);
        AxisCategoryStringCondition yC71 = new AxisCategoryStringCondition("71.0", year);
        AxisCategoryStringCondition yC72 = new AxisCategoryStringCondition("72.0", year);
        AxisCategoryStringCondition yC73 = new AxisCategoryStringCondition("73.0", year);
        AxisCategoryStringCondition yC74 = new AxisCategoryStringCondition("74.0", year);
        AxisCategoryStringCondition yC75 = new AxisCategoryStringCondition("75.0", year);
        AxisCategoryStringCondition yC76 = new AxisCategoryStringCondition("76.0", year);
        AxisCategoryStringCondition yC77 = new AxisCategoryStringCondition("77.0", year);
        AxisCategoryStringCondition yC78 = new AxisCategoryStringCondition("78.0", year);
        AxisCategoryStringCondition yC79 = new AxisCategoryStringCondition("79.0", year);
        AxisCategoryStringCondition yC80 = new AxisCategoryStringCondition("80.0", year);
        AxisCategoryStringCondition yC81 = new AxisCategoryStringCondition("81.0", year);
        AxisCategoryStringCondition yC82 = new AxisCategoryStringCondition("82.0", year);
        
        AxisCategoryOrCondition yC70_72 = new AxisCategoryOrCondition(yC70, yC71, yC72);
        AxisCategoryOrCondition yC73_75 = new AxisCategoryOrCondition(yC73, yC74, yC75);
        AxisCategoryOrCondition yC76_78 = new AxisCategoryOrCondition(yC76, yC77, yC78);
        AxisCategoryOrCondition yC79_82 = new AxisCategoryOrCondition(yC79, yC80, yC81, yC82);
        
        
        AxisCategoryAndCondition aC1 = new AxisCategoryAndCondition();
        aC1.addCondition(eC);
        aC1.addCondition(cC);
        aC1.addCondition(wC1);
        
        AxisCategoryAndCondition aC2 = new AxisCategoryAndCondition();
        aC2.addCondition(eC);
        aC2.addCondition(cC);
        aC2.addCondition(wC2);
        
        Parameter p = new Parameter("aggregated", ds);
        p.numeric = false;
        ds.addParameter(p);
        
        Parameter y = new Parameter("year_", ds);
        y.numeric = false;
        ds.addParameter(y);
        
        year.setParent(y);
        
        for(int i = 0; i < ds.getDesignCount(); i++) {
            Design d = ds.getDesign(i);

            if(aC1.test(d)) {
                d.setValue(p, "ac1");
            }
            else if(aC2.test(d)) {
                d.setValue(p, "ac2");
            }
            else if(cC.test(d)) {
                d.setValue(p, "rest with 6");
            }
            else {
                d.setValue(p, "other");
            }
            
            if(yC70_72.test(d)) {
                d.setValue(y, "70-72");
            }
            else if(yC73_75.test(d)) {
                d.setValue(y, "73-75");
            }
            else if(yC76_78.test(d)) {
                d.setValue(y, "76-78");
            }
            else {
                d.setValue(y, "79-82");
            }
        }
    }
}
