/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.example;

import java.io.IOException;
import javax.swing.ProgressMonitor;
import org.xdat.Main;
import org.xdat.UserPreferences;
import org.xdat.chart.AxisCategoryAndCondition;
import org.xdat.chart.AxisCategoryStringCondition;
import org.xdat.chart.ParallelSetsAxis;
import org.xdat.chart.ParallelSetsChart;
import org.xdat.data.DataSheet;
import org.xdat.data.Design;
import org.xdat.data.Parameter;
import org.xdat.exceptions.NoParametersDefinedException;
import org.xdat.gui.frames.ChartFrame;

/**
 *
 * @author cmolikl
 */
public class Titanic {
    public static void main(String... args) {
        try {
            String filePath = args[0];
            String delimiter = args[1];
            Boolean header = Boolean.parseBoolean(args[2]);
            
            Main main = new Main();
            
            UserPreferences userPreferences = UserPreferences.getInstance();
            userPreferences.setDelimiter(delimiter);
            userPreferences.setTreatConsecutiveAsOne(false);
           
            ProgressMonitor progressMonitor = new ProgressMonitor(main, "", "Importing Data...", 0, 100);
            progressMonitor.setProgress(0);

            DataSheet dataSheet = new DataSheet(filePath, header, main, progressMonitor);
            
            //aggregate(dataSheet);
            
            main.setDataSheet(dataSheet);
            main.repaint();
            
            progressMonitor = new ProgressMonitor(main, "", "Creating chart...", 0, 100);
            progressMonitor.setProgress(0);
            //((ParallelSetsAxis) chart.getAxis("Class")).setProportional(false);
            //((ParallelSetsAxis) chart.getAxis("Age")).setProportional(false);
            //((ParallelSetsAxis) chart.getAxis("Survived")).getCategory(0).setActive(false);

            // TODO get ColumnModel for chart
            ParallelSetsChart chart = new ParallelSetsChart(dataSheet, null, progressMonitor, main.getUniqueChartId(ParallelSetsChart.class));
	    ChartFrame chartFrame = new ChartFrame(main, chart);
            main.getCurrentSession().addChart(chart);
            
            
        }
        catch(IOException e) {
            e.printStackTrace();
        } catch (NoParametersDefinedException ex) {
            ex.printStackTrace();
        }
    }
    
    public static void aggregate(DataSheet ds) {
        Parameter s = ds.getParameter("Survived");
        Parameter a = ds.getParameter("Age");
        Parameter sex = ds.getParameter("Sex");
        
        AxisCategoryStringCondition child = new AxisCategoryStringCondition("Child", a);
        AxisCategoryStringCondition adult = new AxisCategoryStringCondition("Adult", a);
        AxisCategoryStringCondition female = new AxisCategoryStringCondition("Female", sex);
        AxisCategoryStringCondition male = new AxisCategoryStringCondition("Male", sex);
        AxisCategoryStringCondition survived = new AxisCategoryStringCondition("Survived", s);
        AxisCategoryStringCondition perished = new AxisCategoryStringCondition("Perished", s);
        
        //AxisCategoryAndCondition survivedChild = new AxisCategoryAndCondition();
        //survivedChild.addCondition(survived);
        //survivedChild.addCondition(child);
        AxisCategoryAndCondition perishedChild = new AxisCategoryAndCondition();
        perishedChild.addCondition(perished);
        perishedChild.addCondition(child);
        //AxisCategoryAndCondition survidedAdult = new AxisCategoryAndCondition();
        //survidedAdult.addCondition(survived);
        //survidedAdult.addCondition(adult);
        AxisCategoryAndCondition perishedAdult = new AxisCategoryAndCondition();
        perishedAdult.addCondition(perished);
        perishedAdult.addCondition(adult);
        //perishedAdultMale.addCondition(male);
        
        AxisCategoryAndCondition perishedAdultFemale = new AxisCategoryAndCondition();
        perishedAdultFemale.addCondition(perished);
        perishedAdultFemale.addCondition(adult);
        perishedAdultFemale.addCondition(female);
        
        Parameter p = new Parameter("aggregated", ds);
        p.numeric = false;
        ds.addParameter(p);
        
        for(int i = 0; i < ds.getDesignCount(); i++) {
            Design d = ds.getDesign(i);

//            if(survivedChild.test(d)) {
//                d.setValue(p, "Survived Child");
//            }
//            else 
            if(perishedChild.test(d)) {
                d.setValue(p, "Perished Child");
            }
            else if(perishedAdult.test(d)) {
                d.setValue(p, "Perished Adult");
            }
//            else if(perishedAdultFemale.test(d)) {
//                d.setValue(p, "Perished Adult Female");
//            }
            else {
                d.setValue(p, "Other");
            }

        }
    }
}
