package org.xdat.gui.dialogs;

import org.xdat.Main;
import org.xdat.chart.ParallelSetsChart;
import org.xdat.gui.frames.ChartFrame;
import org.xdat.gui.panels.ParallelSetsChartPanel;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ParallelSetsDisplaySettingsDialog extends JDialog {

    private ParallelSetsChart chart;
    private ParallelSetsChartPanel chartPanel;

    public ParallelSetsDisplaySettingsDialog(ChartFrame parent, Main mainWindow) {
        super(parent, "Display Settings");
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        this.chart = (ParallelSetsChart) parent.getChart();
        this.chartPanel = (ParallelSetsChartPanel) parent.getChartPanel();

        setLayout(new BorderLayout());
        JPanel mainPanel = new JPanel(new BorderLayout());
        JPanel controlPanel = new JPanel(new FlowLayout());
        mainPanel.add(controlPanel, BorderLayout.CENTER);
        JPanel buttonsPanel = new JPanel(new FlowLayout());
        mainPanel.add(buttonsPanel, BorderLayout.SOUTH);

        JCheckBox axisLblOffset = new JCheckBox("Axis label offset");
        axisLblOffset.setSelected(chart.isVerticallyOffsetAxisLabels());
        axisLblOffset.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                boolean newOffset = axisLblOffset.isSelected();
                chart.setVerticallyOffsetAxisLabels(newOffset);
                chart.update();
                chartPanel.repaint();
            }
        });
        controlPanel.add(axisLblOffset);

        JButton okButton = new JButton("OK");
        okButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                dispose();
            }
        });
        buttonsPanel.add(okButton);

        add(mainPanel, BorderLayout.CENTER);


        Dimension parentSize = parent.getSize();
        setSize(new Dimension(300, 150));
        int xPos = Math.max(parent.getX()+(int) (0.5 * (parentSize.width - getSize().width)), 0);
        int yPos = Math.max(parent.getY()+((int) (0.5 * (parentSize.height - getSize().height))), 0);
        setLocation(xPos, yPos);
        this.setVisible(true);
    }
}
