/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.xdat.gui.dialogs;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Dictionary;
import java.util.Hashtable;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.ListSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import org.xdat.Main;
import org.xdat.chart.AxisCategory;
import org.xdat.chart.AxisCategoryRangeCondition;
import org.xdat.chart.AxisCategoryStringCondition;
import org.xdat.chart.ParallelSetsAxis;
import org.xdat.chart.ParallelSetsChart;
import org.xdat.data.Design;
import org.xdat.data.Parameter;
import org.xdat.gui.frames.ChartFrame;
import org.xdat.gui.panels.ParallelSetsChartPanel;

/**
 *
 * @author Martin
 */
public class SplitMergeCategoriesDialog extends JDialog {
    
    private DefaultListModel<AxisCategory> listModel;
    private JList<AxisCategory> list;
    private DoubleSlider slider;
    private JLabel labelSplit1;
    private JLabel labelSplit2;
    private JLabel labelSplitHeader;
    private JButton splitButton;
    private JButton mergeButton;
    
    private ParallelSetsAxis axis;
    
    private ParallelSetsChart chart;
    
    private ParallelSetsChartPanel chartPanel;
    
    public SplitMergeCategoriesDialog(ChartFrame parent, Main mainWindow, ParallelSetsAxis axis){
        super(parent, "Split / Merge Categories");
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        
        this.axis = axis;
        this.chart = (ParallelSetsChart) parent.getChart();
        this.chartPanel = (ParallelSetsChartPanel) parent.getChartPanel();
                
        // create components
        setLayout(new BorderLayout());
        JPanel mainPanel = new JPanel(new BorderLayout());
        JPanel controlsPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        JPanel centerPanel = new JPanel(new BorderLayout(5, 5));
        JPanel listPanel = new JPanel(new BorderLayout());
        JPanel splitPanel = new JPanel(new BorderLayout());
        JPanel splitHeadPanel = new JPanel(new BorderLayout());
        JPanel splitCenterPanel = new JPanel(new BorderLayout());
        JPanel splitDescPanel = new JPanel(new GridLayout(1, 2, 20, 0));
        JPanel splitLabel1Panel = new JPanel(new FlowLayout(FlowLayout.RIGHT));
        splitLabel1Panel.setPreferredSize(new Dimension(150, 50));
        JPanel splitLabel2Panel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        splitLabel2Panel.setPreferredSize(new Dimension(150, 50));
        JPanel sliderPanel = new JPanel(new BorderLayout());
        sliderPanel.setPreferredSize(new Dimension(200, 100));
        JPanel buttonsPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
        
	JScrollPane listScrollPane = new JScrollPane();
        JScrollPane sliderScrollPane = new JScrollPane();
        
        splitButton = new JButton("Split");
	mergeButton = new JButton("Merge");
	JButton cancelButton = new JButton("Cancel");
	JButton okButton = new JButton("Ok");
        
        labelSplitHeader = new JLabel("Split to:");
        labelSplit1 = new JLabel();
        labelSplit2 = new JLabel();
        
        listModel = new DefaultListModel<>();
        updateListModel();
        list = new JList<>(listModel);
        list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        
        slider = new DoubleSlider(JSlider.VERTICAL);
        
        // add action listener
        splitButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                splitButtonActionPerformed(e);
            }
        });
        mergeButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                mergeButtonActionPerformed(e);
            }
        });
        list.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                listValueChanged(e);
            }
        });
        slider.addChangeListener(new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                sliderStateChanged(e);
            }
        });
        okButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                okButtonActionPerformed(e);
            }
        });
        
        // add components
        this.add(mainPanel, BorderLayout.CENTER);
        mainPanel.add(controlsPanel, BorderLayout.NORTH);
	mainPanel.add(centerPanel, BorderLayout.CENTER);
	mainPanel.add(buttonsPanel, BorderLayout.SOUTH);
        
        controlsPanel.add(splitButton);
        controlsPanel.add(mergeButton);
        
        centerPanel.add(listPanel, BorderLayout.CENTER);
        centerPanel.add(splitPanel, BorderLayout.EAST);
        
        //buttonsPanel.add(cancelButton);
	buttonsPanel.add(okButton);
        
        listPanel.add(listScrollPane);
        listScrollPane.setViewportView(list);
        
        splitPanel.add(splitHeadPanel, BorderLayout.NORTH);
        splitPanel.add(splitCenterPanel, BorderLayout.CENTER);
        
        splitHeadPanel.add(labelSplitHeader);
        
        splitCenterPanel.add(splitDescPanel, BorderLayout.NORTH);
        splitCenterPanel.add(sliderPanel, BorderLayout.CENTER);
        
        splitDescPanel.add(splitLabel1Panel);
        splitDescPanel.add(splitLabel2Panel);
        
        splitLabel1Panel.add(labelSplit1);
        splitLabel2Panel.add(labelSplit2);
        
        sliderPanel.add(sliderScrollPane);
        sliderScrollPane.setViewportView(slider);
        
	
        
	deactivateSlider();
        splitButton.setEnabled(false);
        mergeButton.setEnabled(false);
        
        Dimension parentSize = parent.getSize();
	setSize(new Dimension(500, 400));
	int xPos = Math.max(parent.getX()+(int) (0.5 * (parentSize.width - getSize().width)), 0);
	int yPos = Math.max(parent.getY()+((int) (0.5 * (parentSize.height - getSize().height))), 0);
	setLocation(xPos, yPos);
	this.setVisible(true);
    }

    private void updateListModel(){
        listModel.clear();
//        List<AxisCategory> sortedCategories = new ArrayList<>(axis.getCategories());
//        sortedCategories.sort(new Comparator<AxisCategory>() {
//            @Override
//            public int compare(AxisCategory c1, AxisCategory c2) {
//                if(c1.getAxis().getParameter().isNumeric()) {
//                    AxisCategoryRangeCondition rc1 = (AxisCategoryRangeCondition) c1.getCondition();
//                    AxisCategoryRangeCondition rc2 = (AxisCategoryRangeCondition) c2.getCondition();
//                    
//                    return Double.compare(rc1.getMin(), rc2.getMin());
//                }
//                else {
//                    AxisCategoryStringCondition rc1 = (AxisCategoryStringCondition) c1.getCondition();
//                    AxisCategoryStringCondition rc2 = (AxisCategoryStringCondition) c2.getCondition();
//                    
//                    return rc1.getString().compareToIgnoreCase(rc2.getString());
//                }
//            }
//        });
        for(AxisCategory category : axis.getCategories()){
            if(!category.getCondition().getClass().equals(AxisCategoryRangeCondition.class)) continue;
            listModel.addElement(category);
        }
    }
    
    private void deactivateSlider(){
        slider.setVisible(false);
        labelSplit1.setVisible(false);
        labelSplit2.setVisible(false);
        labelSplitHeader.setEnabled(false);
    }
    
    private void activateSlider(){
        slider.setVisible(true);
        labelSplit1.setVisible(true);
        labelSplit2.setVisible(true);
        labelSplitHeader.setEnabled(true);
    }
    
    private void okButtonActionPerformed(ActionEvent e){
        this.dispose();
    }
    
    private void splitButtonActionPerformed(ActionEvent e){
        List<AxisCategory> selectedCategories = list.getSelectedValuesList();
        if(selectedCategories.size() != 1) return;
        AxisCategory category = selectedCategories.get(0);
        if(!axis.getParameter().isNumeric()) {
        } else {
            chart.splitCategory(category, slider.getDoubleValue());
            
        
//            AxisCategoryRangeCondition condition = (AxisCategoryRangeCondition) category.getCondition();
//            AxisCategoryRangeCondition c1 = new AxisCategoryRangeCondition(condition.getMin(), slider.getDoubleValue(), p);
//            AxisCategoryRangeCondition c2 = new AxisCategoryRangeCondition(slider.getDoubleValue(), condition.getMax(), condition.isClosedEndRange(), p);
//            
//            ArrayList<Design> designs1 = new ArrayList<>();
//            ArrayList<Design> designs2 = new ArrayList<>();
//            for(Design d : category.getDesigns()) {
//                if(c1.test(d)) {
//                    designs1.add(d);
//                }
//                else {
//                    designs2.add(d);
//                }
//            }
//
//            double heightRatio1 = ((double)designs1.size() / (double)category.getDesigns().size()) * category.getHeightRatio();
//            double heightRatio2 = ((double)designs2.size() / (double)category.getDesigns().size()) * category.getHeightRatio();
//
//            AxisCategory cat1 = new AxisCategory(c1, heightRatio1, designs1, axis);
//            AxisCategory cat2 = new AxisCategory(c2, heightRatio2, designs2, axis);
//            int index = axis.getCategories().indexOf(category);
//            axis.getCategories().remove(index);
//            axis.getCategories().add(index, cat1);
//            axis.getCategories().add(index, cat2);

            //chart.buildDesignSets();
            chartPanel.updateLayout();
            chartPanel.repaint();

            updateListModel();
        }
    }
    
    private void mergeButtonActionPerformed(ActionEvent e){
        if(!axis.getParameter().isNumeric()) {
        } else {
            chart.mergeCategories(list.getSelectedValuesList());
            
//            double minValue = Double.MAX_VALUE;
//            double maxValue = Double.MIN_VALUE;
//            AxisCategoryRangeCondition maxCondition = null;
//            double heightRatio = 0;
//            AxisCategory cat = selectedCategories.get(0);
//            //int yOffset = cat.getYOffset();
//            List<Design> designs = new ArrayList<>();
//            int index = axis.getCategories().indexOf(cat);
//            for (AxisCategory category : selectedCategories) {
//                AxisCategoryRangeCondition c = (AxisCategoryRangeCondition) category.getCondition();
//                if(c.getMin() < minValue) minValue = c.getMin();
//                if(c.getMax() > maxValue) {
//                    maxValue = c.getMax();
//                    maxCondition = c;
//                }
//                heightRatio += category.getHeightRatio();
//                designs.addAll(category.getDesigns());
//
//                int i = axis.getCategories().indexOf(category);
//                if(i < index) index = i;
//            }
//            AxisCategoryRangeCondition c = new AxisCategoryRangeCondition(minValue, maxValue, maxCondition.isClosedEndRange(), p);
//            AxisCategory newCategory = new AxisCategory(c, heightRatio, designs, axis);
//
//            axis.getCategories().removeAll(selectedCategories);
//            axis.getCategories().add(index, newCategory);

            //chart.buildDesignSets();
            chartPanel.updateLayout();
            chartPanel.repaint();

            updateListModel();
        }
    }
    
    private void listValueChanged(ListSelectionEvent e){
        List<AxisCategory> values = list.getSelectedValuesList();
        if(values.isEmpty()){ // no category
            deactivateSlider();
            splitButton.setEnabled(false);
            mergeButton.setEnabled(false);
        } 
        else if(values.size() == 1) { // one category
            mergeButton.setEnabled(false);
            AxisCategory category = values.get(0);
            if(!axis.getParameter().isNumeric()) {
//                slider.setMajorTickSpacing(1);
//                slider.setSnapToTicks(true);
//
//                // make labels
//                int labelStep = 1;
//                if((max - min) > 20){
//                    labelStep = 1 +((max - min) / 20);
//                }
//                Dictionary<Integer, JLabel> d = new Hashtable<>();
//                for(int i = min; i < max; i += labelStep){
//                    String s = category.getAxis().getParameter().getStringValueOf(i);
//                    d.put(i, new JLabel(s));
//                }
//
//                slider.setLabelTable(d);
            }
            else {
                AxisCategoryRangeCondition c = (AxisCategoryRangeCondition) category.getCondition();
                double min =  c.getMin();
                double max =  c.getMax();

                if(min == max){
                    deactivateSlider();
                    splitButton.setEnabled(false);
                    return;
                }
                activateSlider();
                splitButton.setEnabled(false);

                slider.setMinimum(min);
                slider.setMaximum(max);

                int step = (int) ((max - min) / 10.0);
                if(step < 1) step = 1;
                slider.setMajorTickSpacing(step);
                slider.setSnapToTicks(false);
                slider.setLabelTable(slider.createStandardLabels(step));
                
                slider.setPaintTicks(true);
                slider.setPaintLabels(true);
            }
        }
        else{
            deactivateSlider();
            splitButton.setEnabled(false);
            mergeButton.setEnabled(true);
        }
    }
    
    private void sliderStateChanged(ChangeEvent e){
        AxisCategory category = list.getSelectedValuesList().get(0);
        Parameter parameter = category.getAxis().getParameter();
        
        double value = slider.getDoubleValue();
        String sMin;
        String sMax;
        String sValueL;
        String sValueR;

        
        if(!parameter.isNumeric()){
//            AxisCategoryStringCondition c = (AxisCategoryStringCondition) category.getCondition();
//            String s = c.getString();
//            sMin = "(" + parameter.getStringValueOf(min);
//            sMax = parameter.getStringValueOf(max) + ")";
//            sValueR = parameter.getStringValueOf(value) + ")";
//            sValueL = "(" + parameter.getStringValueOf(value + 1);
        }
        else {
            AxisCategoryRangeCondition c = (AxisCategoryRangeCondition) category.getCondition();
            double min = c.getMin();
            double max = c.getMax();
            sMin = "<"+min;
            sMax = max+">";
            sValueR = value+">";
            sValueL = "("+value;
            
            
            if(min == value) {
                splitButton.setEnabled(false);
                labelSplit1.setText("");
                labelSplit2.setText("");
            }
            else if(max == value) {
                splitButton.setEnabled(false);
                labelSplit1.setText("");
                labelSplit2.setText("");
            }
            else{
                splitButton.setEnabled(true);
                labelSplit1.setText(sMin + "; " + sValueR);
                labelSplit2.setText(sValueL + "; " + sMax);
            }
        }
    }
    
}
